'A reference to the Phidget22.NET.dll must be added to new projects in VB.Net 
'From the "Project" menu select "Add Reference" 
'From the "Add Reference" window select the "Browse" tab 
'Browse to the directory you installed the Phidgets library to 
'The default is "C:\Program Files\Phidgets" 
'Select "Phidget22.NET.dll" and click "OK" 
'To view objects that have been added, select the "View" menu 
'Select "Object Browser" 
'Then expand the Phidget22.NET.dll item 



Imports Phidget22
Imports Phidget22.Events

Public Class Form1
    Dim WithEvents device As Phidget22.DigitalInput
    Dim open As ExampleUtils.ExampleUtils.CommandLineOpen
    Dim errorBox As ErrorEventBox

    Public Sub New()
        open = New ExampleUtils.ExampleUtils.CommandLineOpen(Me)
        ' This call is required by the Windows Form Designer.
        Phidget22.Phidget.InvokeEventCallbacks = True
        InitializeComponent()
        ' Add any initialization after the InitializeComponent() call.
    End Sub

    Public Sub New(ByVal commandLine As String())
        open = New ExampleUtils.ExampleUtils.CommandLineOpen(Me)
        open.commandLine = commandLine
        Phidget22.Phidget.InvokeEventCallbacks = True
        InitializeComponent()
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        inputmodeCombo.DataSource = [Enum].GetValues(GetType(InputMode))
        inputmodeCombo.SelectedIndex = -1
        psuCombo.DataSource = [Enum].GetValues(GetType(PowerSupply))
        psuCombo.SelectedIndex = -1

        errorBox = New ErrorEventBox(Me)
        device = New Phidget22.DigitalInput()
        open.openCmdLine(device)
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Application.DoEvents()
        If device.Attached Then
            device.Close()
        End If
    End Sub

    Private Sub device_Attach(ByVal sender As Object, ByVal e As Phidget22.Events.AttachEventArgs) Handles device.Attach

        Dim attachedDevice As Phidget22.DigitalInput = CType(sender, Phidget22.DigitalInput)
        PhidgetInfoBox2.FillPhidgetInfo(CType(sender, Phidget22.DigitalInput))

        Select Case attachedDevice.DeviceID
            Case DeviceID.PN_DAQ1400
                psuCombo.SelectedIndex = 0
                inputmodeCombo.SelectedIndex = 0
                settingsBox.Visible = True
        End Select
        outputBox.Visible = True
    End Sub

    Private Sub device_Detach(ByVal sender As Object, ByVal e As Phidget22.Events.DetachEventArgs) Handles device.Detach
        PhidgetInfoBox2.Clear()
        settingsBox.Visible = False
        outputBox.Visible = False
    End Sub

    Private Sub device_Error(ByVal sender As Object, ByVal e As Phidget22.Events.ErrorEventArgs) Handles device.Error
        errorBox.addMessage(e.Description)
    End Sub

    Private Sub device_DigitalInputChange(ByVal sender As Object, ByVal e As Phidget22.Events.DigitalInputStateChangeEventArgs) Handles device.StateChange
        Try
            If (e.State = True) Then
                inputState.BackColor = Color.Black
                inputState.ForeColor = Color.White
                inputState.Text = Environment.NewLine + "True"
            Else
                inputState.BackColor = Color.White
                inputState.ForeColor = Color.Black
                inputState.Text = Environment.NewLine + "False"
            End If
        Catch ex As Exception
            errorBox.addMessage("Error reading input: " + ex.Message)
        End Try
    End Sub

    Private Sub inputmodeCombo_SelectedIndexChanged(sender As Object, e As EventArgs) Handles inputmodeCombo.SelectedIndexChanged
        If (CType(sender, ComboBox).SelectedIndex = -1 Or device Is Nothing) Then
            Return
        End If
        Try
            device.InputMode = CType([Enum].Parse(GetType(InputMode), inputmodeCombo.SelectedValue.ToString()), InputMode)
        Catch ex As Exception
            errorBox.addMessage("Error setting input mode: " + ex.Message)
        End Try
    End Sub

    Private Sub psuCombo_SelectedIndexChanged(sender As Object, e As EventArgs) Handles psuCombo.SelectedIndexChanged
        If (CType(sender, ComboBox).SelectedIndex = -1 Or device Is Nothing) Then
            Return
        End If
        Try
            device.PowerSupply = CType([Enum].Parse(GetType(PowerSupply), psuCombo.SelectedValue.ToString()), PowerSupply)
        Catch ex As Exception
            errorBox.addMessage("Error setting power supply mode: " + ex.Message)
        End Try
    End Sub
End Class



